﻿using System;
using System.Collections.Generic;

namespace CV1
{
    class MyStack<T> : IEnumerable<T>
    {
        private T[] array = new T[10];
        private int top = -1;

        public event EventHandler OnPush;
        public event EventHandler OnPop;

        public void Push(T elem)
        {
            if (OnPush != null)
                OnPush(this, EventArgs.Empty);

            array[++top] = elem;
        }

        public T Pop()
        {
            if (OnPop != null)
                OnPop(this, EventArgs.Empty);

            return array[top--];
        }

        public T Top
        {
            get
            {
                if (top < 0)
                    throw new ApplicationException("MyStack is empty!");

                return array[top];
            }
        }

        public IEnumerator<T> GetEnumerator()
        {
            for (int i = 0; i <= top; i++)
            {
                yield return array[i];
            }
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }
}
