﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CV1
{
    class Program
    {
        static void Main(string[] args)
        {
            // Stack
            MyStack<int> stack = new MyStack<int>();
            stack.OnPush += PushMethod1;
            stack.OnPush += PushMethod2;
            stack.OnPop += PopMethod;

            stack.Push(1);
            stack.Push(2);


            Console.WriteLine(stack.Top);
            Console.WriteLine(stack.Pop());
            Console.WriteLine(stack.Pop());

            try
            {
                Console.WriteLine(stack.Top);
            }
            catch (ApplicationException ex)
            {
                Console.WriteLine("Error: " + ex.Message);
            }

            // Delegates & Events
            Calculator c = new Calculator();

            Operation op = new Operation(Add);
            c.Write(8, 3, op);
            c.Write(8, 3, Sub);
            c.Write(8, 3, delegate (int x, int y) { return x * y; });
            c.Write(8, 3, (x, y) => x / y);

            c.OnSetXY += SetXYSubscriber1;
            c.OnSetXY += (s, e) => { Console.WriteLine("Lambda subscriber {0}", e.SetXYDate); };

            c.SetXY(3, 2);
        }

        static void PushMethod1(object sender, EventArgs e)
        {
            Console.WriteLine("Push method 1");
        }

        static void PushMethod2(object sender, EventArgs e)
        {
            Console.WriteLine("Push method 2");
        }

        static void PopMethod(object sender, EventArgs e)
        {
            Console.WriteLine("Pop method");
        }

        static int Add(int x, int y)
        {
            return x + y;
        }

        static int Sub(int x, int y)
        {
            return x - y;
        }

        static void SetXYSubscriber1(object sender, CalculatorEventArgs args)
        {
            Console.WriteLine("Subscriber 1: {0}", args.SetXYDate);
        }
    }
}
